package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PaySupplyAddBo;
import com.zhongzheng.modules.pay.bo.PaySupplyQueryBo;
import com.zhongzheng.modules.pay.bo.PaySupplyEditBo;
import com.zhongzheng.modules.pay.domain.PaySupply;
import com.zhongzheng.modules.pay.mapper.PaySupplyMapper;
import com.zhongzheng.modules.pay.vo.PaySupplyVo;
import com.zhongzheng.modules.pay.service.IPaySupplyService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 供应方Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PaySupplyServiceImpl extends ServiceImpl<PaySupplyMapper, PaySupply> implements IPaySupplyService {

    @Override
    public PaySupplyVo queryById(Long supplyId){
        PaySupplyQueryBo paySupplyQueryBo = new PaySupplyQueryBo();
        paySupplyQueryBo.setSupplyId(supplyId);
        return entity2Vo(baseMapper.queryList(paySupplyQueryBo)).get(0);
    }

    @Override
    public List<PaySupplyVo> queryList(PaySupplyQueryBo bo) {
        return entity2Vo(baseMapper.queryList(bo));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PaySupplyVo> entity2Vo(Collection<PaySupplyVo> collection) {
        List<PaySupplyVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PaySupplyVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PaySupplyVo> page = (Page<PaySupplyVo>)collection;
            Page<PaySupplyVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PaySupplyAddBo bo) {
        PaySupply add = BeanUtil.toBean(bo, PaySupply.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PaySupplyEditBo bo) {
        PaySupply update = BeanUtil.toBean(bo, PaySupply.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PaySupply entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
